//+------------------------------------------------------------------+
//|                                                     Big Chic.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
//#property indicator_chart_window
#property  indicator_chart_window
#define  up "Up"
#define  down "Down"
#define  ranging "Range"
//#define  H_ranging "Range"
#define  none "None"
extern string   pd="----Trad pair inputs----";
//extern string	PairsToTrade = "EURUSD,AUDUSD,GBPUSD,NZDUSD,USDCAD,USDCHF,USDJPY,XAGUSD,XAUUSD";  //Obsolete
extern bool    ShowRangingPairs=true;

//+------------------------------------------------------------------+
//| DAILY                                                            |
//+------------------------------------------------------------------+
//MA. Rising MA the trend is up and vice-versa
extern int     RiskDollars=5;
extern string  sima="Trend line inputs";
extern int     TL_MaTdTF=240;//Time frame defaults to 4 hour
extern int     TL_MaTdPeriod=49; // 49 day MA
extern int     TL_MaTdShift=0;//The MA Shift input
extern string  stmame="Method: 0=sma; 1=ema; 2=smma;  3=lwma";
extern int     TL_MaTdMethod=0;
extern string  stmaap="Applied price: 0=Close; 1=Open; 2=High";
extern string  stmaap1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     TL_MaTdAppliedPrice=0;
extern int     TlCompareWithCandles=1;  // Originally set at 5. I changed so as to compare last and 2nd last CLOSES
extern int     TlMinimumAcceptableMove=1;//Pure guesswork to make sure there has bee a decent movement in the ma
                                         //***Must look at this*** was originally 100 
//Short Line specs on a 4 hour time frame.
extern string  stm="Short-term momentum line inputs (SL)";
extern int     SL_Tf=240;
extern int     SL_FastMA=3;
extern int     SL_SlowMA=10;

//Intermediate Line (ML, Middle Line) specs on a 1 day time frame.
extern string  itm="Intermediate-term MA of SL line inputs (IL)";
extern int     Il_Period=16;
extern int     IlCompareWithCandles=5; //***Must look at this***
                                        //Spread
extern string  spr="----Spread----";
extern bool    ShowSpread=true;

// ATR 14 on 2 hour candles
extern int     ATR1Period=14;
extern int     ATR1Timeframe = 60;
extern int     ATR4Timeframe = 240;
extern int     ATR24Timeframe = 1440;
// Closing price 
extern int     CurrPriceTimeframe=240; // get close price on last candle
                                        //***Must look at this*** maybe make it 5                                       
//Dashboard display
extern string  pci="----Stats display inputs----";
extern string  BigChicFont="Arial";
extern int     FontSizeBigChic=12;
extern int     FontSize=8;
extern int     FontSizeFine=8; //9
extern int     FontSizePair=16;
extern int     FontSizePrice=8;

extern color   PairColour=DarkSlateGray;
extern color   BigChicColour=Black;
extern color   LongTrendColour=DarkGreen;
extern color   ShortTrendColour=Red;
extern color   RangingColour=Olive;
extern color   PriceColour=Black;
extern color   BoxColour=Khaki;
extern color   TradeColour=LimeGreen;
extern color   PriceDirectionColour=Olive;
extern double  DisplayStartsAtRow=2;
extern double  RowSpacing=1;//1
extern double  DisplayStartsAtCol=9;
extern double  ColumnSpacing=30;//50
extern string  cols="Colours";
extern double  BoxTop=-6;
extern double  BoxLeft=-43;
extern double  BoxTop2=0;


//string  Symbol();
string TradePair =Symbol();


//extern string  TradePair=Symbol();			//Array to hold the pairs traded by the user

// Account info
double AccountBal=6500;
double RiskPercent=6.0;
//Pair extraction
int      NoOfPairs;            // Holds the number of pairs passed by the user via the inputs screen
                               //Trend detection
string  trend;
string  FutureTrend;
//MACD main - SL or short term momentum line
double  SL,PrevSL;
string  SlTrend;
//MACD signal - IL or intermediate line
double  IL,PrevIL;
string  IlTrend;
//Points count
double LongPointsCount,ShortPointsCount;
//ATR
double ATRmultiplier50=0.5; //BH
int    ATR1; // 1 hour ATR
double ATR4; // 4 hour ATR
double ATR24; // 1 Day ATR
double ATR4Real; // 4 hour ATR - as a decimal
double ATRx; // ATR between 1H & 4H 
double TakeProfPips; // 
double TakeProfPipsL;
double StopLossPips; //
double StopLossPipsL;
double PercentATR;
int    PercentATR50=50; //BH
double Spread1;
double SSMagnitude;
// Current closing price
double CurrPrice;
// Line Values
double EntryLineV;
double ProfitLineV;
double LossLineV;
double SwingHighLineV;
double SwingLowLineV;
double TESTELINE;
double EntryPips;
double RiskReward;
string PriceDirection;
string TradePossible="";

double EntryR;
double ProfitR;
double LossR;
int    OandaUnits;
double EntryLine;
double ProfitLine;
double LossLine;
double SwingHighLine;
double SwingLowLine;
double  StopAdjust;
double  ProfitAdjust;
double  EntryAdjust;

//Future Trend variables
double SMA49;
double SMA48;
double SMA47;
double SMA46;
double SMA45;
double SMA44;
double PrevSMA49;
double PrevSMA48;
double LatestClose;
double ATRD1;
double FutureSMA49a;
double FutureSMA49b;
double FutureSMA49c;
double FutureSMA49d;
double FutureSMA49e;
string  trend2;
string  trend3;
string  trend4;
string  trend5;
string  trend6;

// SS Magnitude
double SSMEntry;
double EntryPrice;
double SSMStop;

//Misc
string   LabelPrefix="Big Chic ";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//int init()
//  {
//LabelPrefix = "Big Chic ";
 // }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   RemoveObjects(LabelPrefix);
   return(0);
  }
//+------------------------------------------------------------------+
//| Remove Objects function. Called in Deint function to clear all   |                                     
//+------------------------------------------------------------------+
void RemoveObjects(string Pref)
  {
   int i;
   string objname="";
   for(i=ObjectsTotal(); i>=0; i--)
     {
      objname=ObjectName(i);
      if(StringFind(objname,Pref,0)>-1) ObjectDelete(objname);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|Calculate minimum move for establishing a trend                   |
//+------------------------------------------------------------------+
double AdaptMinAcceptableMove(string symbol)
  {
   int multiplier;
   int digits= MarketInfo(NULL,MODE_DIGITS);  // MODE_DIGITS = Count of digits after decimal point in the symbol prices. For the current symbol, it is stored in the predefined variable Digits
   if(digits== 2|| digits== 4) multiplier= 1; // || means OR
   if(digits == 3 || digits == 5) multiplier = 10;
   if(digits == 6) multiplier = 100;
   if(digits == 7) multiplier = 1000;

   int number=TlMinimumAcceptableMove* multiplier; //changed for testing
   return(number);
  }
//+------------------------------------------------------------------+
//| Find the direction of the SL and the IL                          |                      
//+------------------------------------------------------------------+
void GetSlIl(string symbol)
// Establish the SL & IL figure for the current CLOSE and compare with
// a previous CLOSE.
// The SL is being comparing the last and second last CLOSE
// The IL is comparing the last CLOSE and a CLOSE "IlCompareWithCandles" away. 
// Originally set at 5
  {
//Daily
//Calculate SL
   SL=iMACD(NULL,SL_Tf,SL_FastMA,SL_SlowMA,Il_Period,PRICE_CLOSE,MODE_MAIN,0);
   PrevSL=iMACD(NULL,SL_Tf,SL_FastMA,SL_SlowMA,Il_Period,PRICE_CLOSE,MODE_MAIN,1);
   SlTrend=none;
   if(SL > PrevSL) SlTrend = up;
   if(SL < PrevSL) SlTrend = down;

//Calculate IL
   IL=iMACD(NULL,SL_Tf,SL_FastMA,SL_SlowMA,Il_Period,PRICE_CLOSE,MODE_SIGNAL,0);
   PrevIL=iMACD(NULL,SL_Tf,SL_FastMA,SL_SlowMA,Il_Period,PRICE_CLOSE,MODE_SIGNAL,IlCompareWithCandles);
   IlTrend=none;

   if(IL > PrevIL) IlTrend = up;
   if(IL < PrevIL) IlTrend = down;
  }
//+------------------------------------------------------------------+
//| Get ATR figures                                                  |                      
//+------------------------------------------------------------------+
void GetATR(string symbol)

  {
// get 4 hour ATR 
   ATR4Real=NormalizeDouble(iATR(NULL,ATR4Timeframe,ATR1Period,0)/Point,0);
   ATR24=NormalizeDouble(iATR(NULL,ATR24Timeframe,ATR1Period,0)/Point,0);


   double spread=MarketInfo(NULL,MODE_SPREAD);
   double myPoint;

// Convert points to pips
   if(StringFind(NULL,"JPY",0)>=0) 
     {
      myPoint=0.001;
      ATR4=ATR4Real*myPoint;
      ATR24=ATR24*myPoint;
      spread=spread*0.1;
     }
   else 
     {
      myPoint=0.1;
      ATR4=ATR4Real*myPoint;
      ATR24=ATR24*myPoint;
      ATR4Real=ATR4Real/1000000;
      spread=spread*myPoint;
     }

   //TakeProfPips=ATR4*1;// + spread;//4h ATR +Spread
   //StopLossPips=ATR4*0.5; // 3/4 the 4h ATR
   Spread1=spread;
   

  }
  
//+------------------------------------------------------------------+
//| Get Trend                                                        |                      
//+------------------------------------------------------------------+
//void GetTrend(string symbol)

// {
// Establish Trend - DAILY
//     double point = MarketInfo(TradePair, MODE_POINT);
//     trend = ranging;
//     double TL = GetMa(TradePair, TL_MaTdTF, TL_MaTdPeriod, TL_MaTdShift, TL_MaTdMethod, TL_MaTdAppliedPrice, 0);   
//     double PrevTL = GetMa(TradePair, TL_MaTdTF, TL_MaTdPeriod, TL_MaTdShift, TL_MaTdMethod, TL_MaTdAppliedPrice, TlCompareWithCandles);   
//     int min = AdaptMinAcceptableMove(TradePair);
//     if (TL > PrevTL &&  TL - PrevTL >= (min * point) ) trend = up;
//     if (TL < PrevTL &&  PrevTL - TL >= (min * point) ) trend = down;   
//}
//+-------------------------------------------------------------------+
//| Get SS Magnitude entry and stop loss percentages                                                  |                      
//+-------------------------------------------------------------------+

void GetSSMPercentages(string symbol)
  {
   //This is probaly far from the best way to write this but I can understand
   //it easily and it won't take me a day to find the correct way.
   SSMagnitude =((SwingHighLineV-SwingLowLineV)/ATR4)*10000;
   SSMEntry=0;
   if(SSMagnitude <= 2.0 && SSMEntry==0)SSMEntry=83.8;
   if(SSMagnitude <= 2.1 && SSMEntry==0)SSMEntry=80.1;
   if(SSMagnitude <= 2.2 && SSMEntry==0)SSMEntry=76.4;
   if(SSMagnitude <= 2.3 && SSMEntry==0)SSMEntry=74.2;
   if(SSMagnitude <= 2.4 && SSMEntry==0)SSMEntry=71.7;
   if(SSMagnitude <= 2.5 && SSMEntry==0)SSMEntry=69.7;
   if(SSMagnitude <= 2.6 && SSMEntry==0)SSMEntry=67.7;
   if(SSMagnitude <= 2.7 && SSMEntry==0)SSMEntry=65.7;
   if(SSMagnitude <= 2.8 && SSMEntry==0)SSMEntry=64.3;
   if(SSMagnitude <= 2.9 && SSMEntry==0)SSMEntry=62.3;
   if(SSMagnitude <= 3.0 && SSMEntry==0)SSMEntry=60.3;
   if(SSMagnitude <= 3.1 && SSMEntry==0)SSMEntry=58.8;
   if(SSMagnitude <= 3.2 && SSMEntry==0)SSMEntry=56.8;
   if(SSMagnitude <= 3.3 && SSMEntry==0)SSMEntry=55.3;
   if(SSMagnitude <= 3.4 && SSMEntry==0)SSMEntry=53.9;
   if(SSMagnitude <= 3.5 && SSMEntry==0)SSMEntry=52.4;
   if(SSMagnitude <= 3.6 && SSMEntry==0)SSMEntry=50.9;
   if(SSMagnitude <= 3.7 && SSMEntry==0)SSMEntry=49.4;
   if(SSMagnitude <= 3.8 && SSMEntry==0)SSMEntry=48.2;
   if(SSMagnitude <= 3.9 && SSMEntry==0)SSMEntry=46.9;
   if(SSMagnitude <= 4.0 && SSMEntry==0)SSMEntry=45.5;
   if(SSMagnitude <= 4.1 && SSMEntry==0)SSMEntry=44.5;
   if(SSMagnitude <= 4.2 && SSMEntry==0)SSMEntry=43;
   if(SSMagnitude <= 4.3 && SSMEntry==0)SSMEntry=42;
   if(SSMagnitude <= 4.4 && SSMEntry==0)SSMEntry=41;
   if(SSMagnitude <= 4.5 && SSMEntry==0)SSMEntry=39.5;
   if(SSMagnitude <= 4.6 && SSMEntry==0)SSMEntry=38.5;
   if(SSMagnitude <= 4.7 && SSMEntry==0)SSMEntry=37.6;
   if(SSMagnitude <= 4.8 && SSMEntry==0)SSMEntry=36.1;
   if(SSMagnitude <= 4.9 && SSMEntry==0)SSMEntry=35.1;
   if(SSMagnitude <= 5.0 && SSMEntry==0)SSMEntry=34.1;
   if(SSMagnitude <= 5.1 && SSMEntry==0)SSMEntry=32.8;
   if(SSMagnitude <= 5.2 && SSMEntry==0)SSMEntry=32.4;
   if(SSMagnitude <= 5.3 && SSMEntry==0)SSMEntry=31.1;
   if(SSMagnitude <= 5.4 && SSMEntry==0)SSMEntry=30.6;
   if(SSMagnitude <= 5.5 && SSMEntry==0)SSMEntry=29.6;
   if(SSMagnitude <= 5.6 && SSMEntry==0)SSMEntry=28.6;
   if(SSMagnitude <= 5.7 && SSMEntry==0)SSMEntry=28.2;
   if(SSMagnitude <= 5.8 && SSMEntry==0)SSMEntry=27.2;
   if(SSMagnitude <= 5.9 && SSMEntry==0)SSMEntry=26.2;
   if(SSMagnitude <= 6.0 && SSMEntry==0)SSMEntry=25.7;
   if(SSMagnitude <= 6.1 && SSMEntry==0)SSMEntry=24.9;
   if(SSMagnitude <= 6.2 && SSMEntry==0)SSMEntry=24.2;
   if(SSMagnitude <= 6.3 && SSMEntry==0)SSMEntry=23.7;
   if(SSMagnitude <= 6.4 && SSMEntry==0)SSMEntry=23;
   if(SSMagnitude <= 6.5 && SSMEntry==0)SSMEntry=22.3;
   if(SSMagnitude <= 6.6 && SSMEntry==0)SSMEntry=22.1;
   if(SSMagnitude <= 6.7 && SSMEntry==0)SSMEntry=21.6;
   if(SSMagnitude <= 6.8 && SSMEntry==0)SSMEntry=21.1;
   if(SSMagnitude <= 6.9 && SSMEntry==0)SSMEntry=21;
   if(SSMagnitude <= 7.0 && SSMEntry==0)SSMEntry=20.8;
   if(SSMagnitude <= 7.1 && SSMEntry==0)SSMEntry=20.5;
   if(SSMagnitude > 7.1 && SSMEntry==0)SSMEntry=20.5;
   
   SSMStop=0;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   if(SSMagnitude <= 2.0 && SSMStop==0)SSMStop=104.2;
   
   
   
   
   
   
   
   EntryPrice=SwingLowLineV+(((SwingHighLineV-SwingLowLineV)*SSMEntry)/100);
   
     }
//+-------------------------------------------------------------------+
//| Get Price Action                                                  |                      
//+-------------------------------------------------------------------+
//compare today's price with yesterday's
void GetPriceAction(string symbol)
  {
   double PricePresentHigh;
   double PricePresentLow;
   double PricePastHigh;
   double PricePastLow;

   PricePresentHigh=iHigh(symbol,CurrPriceTimeframe,1);//Today high
   PricePresentLow= iLow(symbol,CurrPriceTimeframe,1);//Today Low
   PricePastHigh = iHigh(symbol,CurrPriceTimeframe,2);//yesterday's high
   PricePastLow=iLow(symbol,CurrPriceTimeframe,2);//yesterday's Low

   PriceDirection="Sideways";
   if((trend == up) && (PricePresentLow > PricePastLow)) PriceDirection = "UP";
   if((trend == down) && (PricePresentLow < PricePastLow)) PriceDirection = "DOWN";
  }
//+-------------------------------------------------------------------+
//| Get Future Trend                                                 |                      
//+-------------------------------------------------------------------+
void GetFutureTrend(string symbol)
   {
   //compare current 4 hourly price with previous 4 hour price  
   double point=MarketInfo(NULL,MODE_POINT);
   trend=ranging;
   SMA49=iMA(NULL,PERIOD_H4,49,0,MODE_SMA,PRICE_CLOSE,0);
   PrevSMA49=iMA(NULL,PERIOD_H4,49,0,MODE_SMA,PRICE_CLOSE,1);
   double min=AdaptMinAcceptableMove(NULL);
   if(SMA49 > PrevSMA49 &&  SMA49 - PrevSMA49 >= (min * point) ) trend = up;
   if(SMA49 < PrevSMA49 &&  PrevSMA49 - SMA49 >= (min * point) ) trend = down;
   
   //Predict trend direction for tomorrows 49 day SMA
   // Get 48 day SMA and add 1/49 of todays close less a percentage of the ATR.
   trend2=ranging;
   SMA48=iMA(NULL,PERIOD_H4,48,0,MODE_SMA,PRICE_CLOSE,0); //48 day MA
   LatestClose=iClose(NULL,PERIOD_H4,0);
   ATRD1=iATR(NULL,PERIOD_H4,14,0);
   if(trend==up)FutureSMA49a=((SMA48*48)+(LatestClose-(ATRD1*0.5)))/49;// if trend up subtract 1 x D1ATR from current to cover downturns
   if(trend==down)FutureSMA49a=((SMA48*48)+(LatestClose+(ATRD1*0.5)))/49;// if trend down add 1 x D1ATR from current to cover upturns
   if(FutureSMA49a > SMA49 &&  FutureSMA49a - SMA49 >= (min * point) ) trend2 = up; 
   if(FutureSMA49a < SMA49 &&  SMA49 - FutureSMA49a >= (min * point) ) trend2 = down;
   
   //Predict trend direction for the day after tomorrows 49 day SMA
   // Get 47 day SMA and add 2/48 of todays close less a percentage of the ATR + 
   trend3=ranging;
   SMA47=iMA(NULL,PERIOD_H4,47,0,MODE_SMA,PRICE_CLOSE,0); //47 day MA
   if(trend==up)FutureSMA49b=((SMA47*47)+(2*(LatestClose-(ATRD1*0.4))))/49;// if trend up subtract 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2)
   if(trend==down)FutureSMA49b=((SMA47*47)+(2*(LatestClose+(ATRD1*0.4))))/49;// if trend down add 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2)
   if(FutureSMA49b > FutureSMA49a &&  FutureSMA49b - FutureSMA49a >= (min * point) ) trend3 = up;
   if(FutureSMA49b < FutureSMA49a &&  FutureSMA49a - FutureSMA49b >= (min * point) ) trend3 = down;
   
   //Predict trend direction for 2 days after tomorrows 49 day SMA
   trend4=ranging;
   SMA46=iMA(NULL,PERIOD_H4,46,0,MODE_SMA,PRICE_CLOSE,0); //46 day MA
   if(trend==up)FutureSMA49c=((SMA46*46)+(3*(LatestClose-(ATRD1*0.3))))/49;// if trend up subtract 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2and 0.6 xatr for day 3)
   if(trend==down)FutureSMA49c=((SMA46*46)+(3*(LatestClose+(ATRD1*0.3))))/49;// if trend down add 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2 and 0.6 xatr for day 3)
   if(FutureSMA49c > FutureSMA49b &&  FutureSMA49c - FutureSMA49b >= (min * point) ) trend4 = up;
   if(FutureSMA49c < FutureSMA49b &&  FutureSMA49b - FutureSMA49c >= (min * point) ) trend4 = down;
   
   //Predict trend direction for 3 days after tomorrows 49 day SMA
   trend5=ranging;
   SMA45=iMA(NULL,PERIOD_H4,45,0,MODE_SMA,PRICE_CLOSE,0); //45 day MA
   if(trend==up)FutureSMA49d=((SMA45*45)+(4*(LatestClose-(ATRD1*0.3))))/49;// if trend up subtract 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2and 0.6 xatr for day 3)
   if(trend==down)FutureSMA49d=((SMA45*45)+(4*(LatestClose+(ATRD1*0.3))))/49;// if trend down add 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2 and 0.6 xatr for day 3)
   if(FutureSMA49d > FutureSMA49c &&  FutureSMA49d - FutureSMA49c >= (min * point) ) trend5 = up;
   if(FutureSMA49d < FutureSMA49c &&  FutureSMA49c - FutureSMA49d >= (min * point) ) trend5 = down;
   
      //Predict trend direction for 4 days after tomorrows 49 day SMA
   trend6=ranging;
   SMA44=iMA(NULL,PERIOD_H4,44,0,MODE_SMA,PRICE_CLOSE,0); //44 day MA
   if(trend==up)FutureSMA49e=((SMA44*44)+(5*(LatestClose-(ATRD1*0.3))))/49;// if trend up subtract 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2and 0.6 xatr for day 3)
   if(trend==down)FutureSMA49e=((SMA44*44)+(5*(LatestClose+(ATRD1*0.3))))/49;// if trend down add 0.9 x D1ATR (1atr for day 1 and 0.8 x atr for day 2 and 0.6 xatr for day 3)
   if(FutureSMA49e > FutureSMA49d &&  FutureSMA49e - FutureSMA49d >= (min * point) ) trend6 = up;
   if(FutureSMA49e < FutureSMA49d &&  FutureSMA49d - FutureSMA49e >= (min * point) ) trend6 = down;
   }  
//+------------------------------------------------------------------+
//| Get Current Price                                                  |                      
//+------------------------------------------------------------------+
void GetCurrent(string symbol)
  {
   CurrPrice = iClose(NULL,CurrPriceTimeframe,0);
   //TradePair = Symbol();
   //TradePair = "help";
   
  }
//+------------------------------------------------------------------+
//| Get Moving Average                                          |                      
//+------------------------------------------------------------------+
double GetMa(string symbol,int tf,int period,int mashift,int method,int ap,int shift)
  {
   return(iMA(symbol, tf, period, mashift, method, ap, shift) );
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//double H_GetMa(string symbol,int H_tf,int H_period,int mashift,int method,int ap,int shift)
//  {
//   return(iMA(symbol, H_tf, H_period, mashift, method, ap, shift) );
//  }
//+------------------------------------------------------------------+
//| Calculate Chic's Points                                          |                      
//+------------------------------------------------------------------+
void CalculatePoints()
  {
//Daily
   LongPointsCount=0;
   ShortPointsCount=0;

   if(trend == up) LongPointsCount++;          // If Trend up add 1 point
   if(IlTrend == up) LongPointsCount+= 0.5;    // If IL up add 0.5 points
   if(IL > 0) LongPointsCount+= 0.5;           // If IL is above zero add 0.5 points
   if(SlTrend == up) LongPointsCount++;        // If SL is up add 1 point

   if(trend == down) ShortPointsCount++;       // If Trend down add 1 point
   if(IlTrend == down) ShortPointsCount+= 0.5; // If IL down add 0.5 points
   if(IL < 0) ShortPointsCount+= 0.5;          // If IL is below zero add 0.5 points
   if(SlTrend == down) ShortPointsCount++;     // If SL is down add 1 point
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RiskRewardRatio()
  {
   //Risk reward ratio for reccomended TP & SL
   EntryR=EntryLineV;
   ProfitR=ProfitLineV-EntryR;
   LossR=EntryR-LossLineV;

   RiskReward=ProfitR/LossR;

  }
//+------------------------------------------------------------------+
//| Calculate Oanda Units                                          |                      
//+------------------------------------------------------------------+
void CalculateUnits(string symbol)
  {

   double DollarsRisked=RiskDollars;
   double AusPrice;
   double CurrentPrice=CurrPrice;
   double StopLoss;
   
   if(trend==up)EntryAdjust=EntryLineV+(Spread1/10000)+0.00010;
   if(trend==down)EntryAdjust=EntryLineV-0.00010;
   if(trend==up)StopAdjust=LossLineV-0.0002;
   if(trend==down)StopAdjust=LossLineV+(Spread1/10000)-0.0002;
   StopLossPipsL=MathAbs((StopAdjust-EntryAdjust)*10000);

   //if(trend==up)StopLossPipsL=MathAbs((EntryLineV-LossLineV)*10000)-2;
   //if(trend==down)StopLossPipsL=MathAbs((EntryLineV-LossLineV)*10000)+2+Spread1;

   //StopLossPipsL=MathAbs((EntryLineV-LossLineV)*10000);
   StopLoss=StopLossPipsL;

   AusPrice=iClose("AUDUSD",CurrPriceTimeframe,0);

   if(TradePair == "GBPUSD" || TradePair == "EURUSD" ||TradePair == "AUDUSD" ||TradePair == "NZDUSD") OandaUnits = (DollarsRisked *10000)/ StopLoss * AusPrice;
   if(TradePair == "USDCHF" ||TradePair == "USDCAD") OandaUnits = (DollarsRisked *10000)/ StopLoss * AusPrice * CurrentPrice;
   if(TradePair == "USDJPY" ) OandaUnits = (DollarsRisked *100)/ StopLoss * AusPrice * CurrentPrice;
  }
///+------------------------------------------------------------------+
void ShowStats()
//+------------------------------------------------------------------+
  {
//Displays pair-by-pair data in lables on the screen
   RemoveObjects(LabelPrefix);

   double vertical;
   double horizontal;
   string Label_Name;
   int a;

// Get Trend 
   double point=MarketInfo(NULL,MODE_POINT);
   trend=ranging;
   double TL=GetMa(NULL,TL_MaTdTF,TL_MaTdPeriod,TL_MaTdShift,TL_MaTdMethod,TL_MaTdAppliedPrice,0);
   double PrevTL=GetMa(NULL,TL_MaTdTF,TL_MaTdPeriod,TL_MaTdShift,TL_MaTdMethod,TL_MaTdAppliedPrice,TlCompareWithCandles);
   int min=AdaptMinAcceptableMove(NULL);
   if(TL > PrevTL &&  TL - PrevTL >= (min * point) ) trend = up;
   if(TL < PrevTL &&  PrevTL - TL >= (min * point) ) trend = down;
   

//IL/SL readings and point count and ATR
   GetCurrent(NULL);
   GetATR(NULL);
   DrawLines();
   GetSlIl(NULL);
   CalculatePoints();
   GetSSMPercentages(NULL);
   DrawLines2();
   GetPriceAction(NULL);
   RiskRewardRatio();
   CalculateUnits(NULL);
   GetFutureTrend(NULL);

//BackGround Box
   vertical=BoxLeft;
   horizontal = BoxTop;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("n",Label_Name,190,"Wingdings",BoxColour,vertical,horizontal);
   a++;

//BackGround Box extention
   horizontal = BoxTop2;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("n",Label_Name,190,"Wingdings",BoxColour,vertical,horizontal);
   vertical+=ColumnSpacing;
   a++;
   
 //BackGround Box extention 2
   vertical=BoxLeft;
   horizontal = BoxTop2+4;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("n",Label_Name,190,"Wingdings",BoxColour,vertical,horizontal);
   vertical+=ColumnSpacing;
   a++;


//Pair Label
   vertical=DisplayStartsAtCol+5;
   horizontal+= RowSpacing-5;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt(TradePair,Label_Name,FontSizePair,"Arial bLACK",PairColour,vertical,horizontal);
   vertical+=ColumnSpacing;
   a++;

//Current Price
//   vertical=DisplayStartsAtCol+ColumnSpacing+30;
//   horizontal+=RowSpacing+2;// I changed this so details start a row after Big Chic heading
//   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
//   Printtxt(DoubleToStr(CurrPrice,5),Label_Name,FontSizePrice,"Arial",PairColour,vertical,horizontal);
//   a++;
   
   //Is a trade possible
//   TradePossible="WAIT";
//   TradeColour=Orange;
//   if(PriceDirection=="UP" && trend==up && LongPointsCount>1.5)
//     {
//      TradePossible="BUY";
//      TradeColour=LongTrendColour;
//     }
//   if(PriceDirection=="DOWN" && trend==down && ShortPointsCount>1.5)
//     {
//      TradePossible="SELL";
//      TradeColour=ShortTrendColour;
//     }
//   vertical=DisplayStartsAtCol+ColumnSpacing *1.4;
//   horizontal+= RowSpacing-2;
//   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
//   Printtxt(TradePossible,Label_Name,FontSizePair,"Arial Black",TradeColour,vertical,horizontal);
//   vertical+=ColumnSpacing;
//   a++;

//3nd row headings
   vertical=DisplayStartsAtCol;
   horizontal+=RowSpacing+1;// I changed this so details start a row after Big Chic heading
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Trend",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*1.2;
   Label_Name=LabelPrefix+"headlabel"+DoubleToStr(a,0);
   Printtxt("+Count",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*1.2;
   Label_Name=LabelPrefix+"headlabel"+DoubleToStr(a,0);
   Printtxt("-Count",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

//Trend
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   color col= RangingColour;
   if(trend == up) col = LongTrendColour;
   if(trend == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;

//Points count Long - Daily 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt(DoubleToStr(LongPointsCount,1),Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;

//Points count Short - Daily 
   vertical+=ColumnSpacing*1.2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=ShortTrendColour;
   Printtxt(DoubleToStr(ShortPointsCount,1),Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
 //Future Trend
   vertical=DisplayStartsAtCol+9;
   horizontal+=RowSpacing*1.5;
   Label_Name=LabelPrefix+"a";
   Printtxt("EXPECTED TREND",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;  
   
   // Tomorrows trend
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   col= RangingColour;
   if(trend2 == up) col = LongTrendColour;
   if(trend2 == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend2,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
   //Tomorrows trend 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt("4 Hours",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
   
   // Day after tomorrow
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   col= RangingColour;
   if(trend3 == up) col = LongTrendColour;
   if(trend3 == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend3,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
   //Day after tomorrow trend 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt("8 Hours",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
   
   // 2 days after tomorrow trend 
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   col= RangingColour;
   if(trend4 == up) col = LongTrendColour;
   if(trend4 == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend4,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
   // 2 days after tomorrow trend 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt("12 Hours",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
   
      // 3 days after tomorrow trend 
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   col= RangingColour;
   if(trend5 == up) col = LongTrendColour;
   if(trend5 == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend5,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
   // 2 days after tomorrow trend 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt("16 Hours",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
   
      // 4 days after tomorrow trend 
   vertical=DisplayStartsAtCol+5;
   horizontal+=RowSpacing;
   col= RangingColour;
   if(trend6 == up) col = LongTrendColour;
   if(trend6 == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(trend6,Label_Name,FontSize,"Arial",col,vertical,horizontal);
   a++;
   
   // 4 days after tomorrow trend 
   vertical+=ColumnSpacing+12;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=LongTrendColour;
   Printtxt("20 Hours",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
  
// Swing High Line
   vertical=DisplayStartsAtCol*1;
   horizontal+= RowSpacing*1.4;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Swing High",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   //if(trend==up)ProfitAdjust=ProfitLineV-0.00010;
   //if(trend==down)ProfitAdjust=ProfitLineV+(Spread1/10000)+0.00010;
   //if(trend==up)EntryAdjust=EntryLineV+(Spread1/10000)+0.00010;
   //if(trend==down)EntryAdjust=EntryLineV-0.00010;
   

   vertical+=ColumnSpacing *2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
//col = PriceColour;
   Printtxt(DoubleToStr(SwingHighLineV,5),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;
   
   // Swing Low Line
   vertical=DisplayStartsAtCol*1;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Swing Low",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing *2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
//col = PriceColour;
   Printtxt(DoubleToStr(SwingLowLineV,5),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;

 //  TakeProfPipsL=MathAbs((ProfitAdjust-EntryAdjust)*10000);
//   vertical+=ColumnSpacing *1.5;// Insert line PIPS
//   Label_Name=LabelPrefix+DoubleToStr(a,0);
//   Printtxt(DoubleToStr(TakeProfPipsL,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
//   a++;

// Entry Line
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Entry",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing *2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(EntryPrice,5),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;

//   col=White;
//   if(trend==up && CurrPrice > EntryLineV) col = LongTrendColour;
//   if(trend==up && CurrPrice < EntryLineV) col = ShortTrendColour;
//   if(trend==down && CurrPrice < EntryLineV) col = LongTrendColour;
//   if(trend==down && CurrPrice > EntryLineV) col = ShortTrendColour;
   
//   EntryPips=MathAbs((CurrPrice-EntryAdjust)*10000);
//   vertical+=ColumnSpacing *1.5;// Insert line PIPS
//   Label_Name=LabelPrefix+DoubleToStr(a,0);
//   Printtxt(DoubleToStr(EntryPips,1),Label_Name,FontSize,"Arial",col,vertical,horizontal);
//   a++;

// Stop Loss Line
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Stop Loss",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   if(trend==up)StopAdjust=LossLineV-0.0002;
   if(trend==down)StopAdjust=LossLineV+(Spread1/10000)+0.0002;
   vertical+=ColumnSpacing *2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(StopAdjust,5),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;

//  StopLossPipsL=MathAbs((StopAdjust-EntryAdjust)*10000);
//   vertical+=ColumnSpacing *1.5;// Insert line PIPS
//   Label_Name=LabelPrefix+DoubleToStr(a,0);
//   Printtxt(DoubleToStr(StopLossPipsL,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
//   a++;
   
   //SS Magnitude
   
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("SS Magnitude",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*2.5;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(SSMagnitude,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;
   
   //Spread
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Spread",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*2.5;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(Spread1,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;
   
   //4ATR
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + DoubleToStr(a, 0);
   Printtxt("4 Hour ATR",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*2.5;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(ATR4,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;

// Risk Reward
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing*1.3;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Risk Reward",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

//Risk reward ratio for Horizontal Lines TP & SL
   EntryR=EntryAdjust;
   ProfitR=ProfitAdjust-EntryAdjust;
   LossR=EntryAdjust-StopAdjust;
   RiskReward=ProfitR/LossR;

   vertical+=ColumnSpacing *2.5;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(("1:"+DoubleToStr(RiskReward,1)),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;


// Units
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing*1.5;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Units",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(OandaUnits,0),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;

   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + DoubleToStr(a, 0);
   Printtxt("Risk Dollars",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical+=ColumnSpacing*2;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt("$"+RiskDollars,Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;
   




   vertical+=ColumnSpacing;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt("1 Day ATR",Label_Name,FontSize,"Arial",BigChicColour,vertical,horizontal);
   a++;
   
   vertical+=ColumnSpacing*1.7;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   Printtxt(DoubleToStr(ATR24,1),Label_Name,FontSize,"Arial",PriceColour,vertical,horizontal);
   a++;


   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Risk Reward must be above 1:2.0",Label_Name,FontSizeFine,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Daily candle closes 2pm Melbourne time",Label_Name,FontSizeFine,"Arial",BigChicColour,vertical,horizontal);
   a++;

   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
   Printtxt("Chart is on New York time",Label_Name,FontSizeFine,"Arial",BigChicColour,vertical,horizontal);
   a++;


//Show Trade Pair
   vertical=DisplayStartsAtCol;
   horizontal+= RowSpacing;
   int digits = MarketInfo(NULL, MODE_DIGITS);


//GetLineValues();

//Pair Name
//     vertical = DisplayStartsAtCol;
//     Label_Name = LabelPrefix + a;
//     Printtxt(TradePair,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
//     a++;
//Closing Price
   vertical+=ColumnSpacing*2;
   horizontal = DisplayStartsAtRow + RowSpacing*9;
   Label_Name = LabelPrefix + DoubleToStr(a, 0);
//Printtxt(DoubleToStr(CurrPrice, 5),Label_Name,FontSizePrice,"Arial", PairColour,vertical,horizontal);
   a++;

//Trend up or down Daily
   vertical=DisplayStartsAtCol+ColumnSpacing*2.5;
   horizontal+=RowSpacing*4;
//color col = RangingColour;
//if (H_trend == up) col = LongTrendColour;
//if (H_trend == down) col = ShortTrendColour;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
//     Printtxt(H_trend,Label_Name,FontSize,"Arial", col,vertical,horizontal);
   a++;

//Points count Long - daily
   vertical+=ColumnSpacing;
   Label_Name=LabelPrefix+DoubleToStr(a,0); // + DoubleToStr(i, 0) + DoubleToStr(a, 0);
   col=LongTrendColour;
//     Printtxt(DoubleToStr(H_LongPointsCount, 1),Label_Name,FontSize,"Arial", col,vertical,horizontal);
   a++;

//Points count Short - daily
   vertical+=ColumnSpacing;
   Label_Name=LabelPrefix+DoubleToStr(a,0);
   col=ShortTrendColour;
//     Printtxt(DoubleToStr(H_ShortPointsCount, 1),Label_Name,FontSize,"Arial", col,vertical,horizontal);
   a++;

//Trend up or down Hourly

//Points count Long - Hourly 
//     vertical+= ColumnSpacing;               
//     Label_Name = LabelPrefix + DoubleToStr(a, 0);
//     col = LongTrendColour;
//     Printtxt(DoubleToStr(LongPointsCount, 1),Label_Name,FontSize,"Arial", col,vertical,horizontal);
//     a++;

//Points count Short - Hourly 
//     vertical+= ColumnSpacing;
//     Label_Name = LabelPrefix + DoubleToStr(a, 0);
//     col = ShortTrendColour;
//     Printtxt(DoubleToStr(ShortPointsCount, 1),Label_Name,FontSize,"Arial", col,vertical,horizontal);       
//     a++;            





//     vertical+= + ColumnSpacing * 2 + 10;  // Was ColumnSpacing + 10
//     Label_Name = LabelPrefix + DoubleToStr(a, 0);
//     Printtxt(DoubleToStr(Spread1,1),Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
//     vertical+= ColumnSpacing;
//     a++;




//Amount to risk per trade
//     vertical+= ColumnSpacing;
//     Label_Name = LabelPrefix + DoubleToStr(a, 0);
//     col = ShortTrendColour;
//     Printtxt(RiskPercent,Label_Name,FontSize,"Arial", col,vertical,horizontal);       
//     a++;   

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Printtxt(string text,string str,int size,string font,color vcolor,double vertical,double horizontal)
  {
   if(ObjectFind(str)==-1)
     {
      ObjectCreate(str,OBJ_LABEL,0,0,0);
     }
   ObjectSetText(str,text,size,font,vcolor);
   ObjectSet(str,OBJPROP_XDISTANCE,0+vertical);
   ObjectSet(str,OBJPROP_YDISTANCE,0+14.0*horizontal);
  }
// Draw line
void DrawLines()
  {
// Entry Line
   //EntryLine=SwingHighLine-((SwingHighLine-SwingLowLine)*SSMEntry);
   //EntryLine=EntryPrice;
   //LossLine=EntryLine-(0.6*ATR4Real);
   SwingHighLine=CurrPrice +(1.5*ATR4Real);
   SwingLowLine=CurrPrice -(1.5*ATR4Real);

//Entry Line
   //ObjectCreate("ELine",OBJ_HLINE,0,Time[0],EntryLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("ELine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("ELine",OBJPROP_COLOR,Aqua);
//   ObjectSet("ELine",OBJPROP_WIDTH,2);

//Take Profit
//   ObjectCreate("PLine",OBJ_HLINE,0,Time[0],ProfitLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("PLine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("PLine",OBJPROP_COLOR,Lime);
//   ObjectSet("PLine",OBJPROP_WIDTH,2);

//Stop Loss
//   ObjectCreate("SLine",OBJ_HLINE,0,Time[0],LossLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("SLine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("SLine",OBJPROP_COLOR,Red);
//   ObjectSet("SLine",OBJPROP_WIDTH,2);
   
   //Swing High
   ObjectCreate("SHLine",OBJ_HLINE,0,Time[0],SwingHighLine); //name,type,window,time of the first anchor point,price of the first anchor point
   ObjectSet("SHLine",OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("SHLine",OBJPROP_COLOR,Gold);
   ObjectSet("SHLine",OBJPROP_WIDTH,1);
   
   //Swing Low
   ObjectCreate("SLLine",OBJ_HLINE,0,Time[0],SwingLowLine); //name,type,window,time of the first anchor point,price of the first anchor point
   ObjectSet("SLLine",OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("SLLine",OBJPROP_COLOR,PaleGreen);
   ObjectSet("SLLine",OBJPROP_WIDTH,1);
   
   
   
   SwingHighLineV=ObjectGet("SHLine",OBJPROP_PRICE1);
   SwingLowLineV=ObjectGet("SLLine",OBJPROP_PRICE1);
   EntryLineV=ObjectGet("ELine",OBJPROP_PRICE1);
   ProfitLineV=ObjectGet("PLine",OBJPROP_PRICE1);
   LossLineV=ObjectGet("SLine",OBJPROP_PRICE1);
   
   

   
   
//Info box lines. Aeshtetic lines only in display box
  // ObjectCreate("PrettyLine1",OBJ_HLINE,0,Time[0],0); //name,type,window,time of the first anchor point,price of the first anchor point
  // ObjectSet("PrettyLine1",OBJPROP_STYLE,STYLE_SOLID);
  // ObjectSet("PrettyLine1",OBJPROP_XDISTANCE,50);
  // ObjectSet("PrettyLine1",OBJPROP_YDISTANCE,50);
  // ObjectSet("PrettyLine1",OBJPROP_COLOR,Gold);
  // ObjectSet("PrettyLine1",OBJPROP_WIDTH,2);
  }

void DrawLines2()
  {
// Entry Line
   //EntryLine=SwingHighLine-((SwingHighLine-SwingLowLine)*SSMEntry);
   EntryLine=EntryPrice;
   //LossLine=EntryLine-(0.6*ATR4Real);
//   SwingHighLine=CurrPrice +(1.5*ATR4Real);
//   SwingLowLine=CurrPrice -(1.5*ATR4Real);

//Entry Line
   ObjectCreate("ELine",OBJ_HLINE,0,Time[0],EntryLine); //name,type,window,time of the first anchor point,price of the first anchor point
   ObjectSet("ELine",OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("ELine",OBJPROP_COLOR,Aqua);
   ObjectSet("ELine",OBJPROP_WIDTH,1);

//Take Profit
//   ObjectCreate("PLine",OBJ_HLINE,0,Time[0],ProfitLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("PLine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("PLine",OBJPROP_COLOR,Lime);
//   ObjectSet("PLine",OBJPROP_WIDTH,2);

//Stop Loss
   ObjectCreate("SLine",OBJ_HLINE,0,Time[0],LossLine); //name,type,window,time of the first anchor point,price of the first anchor point
   ObjectSet("SLine",OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("SLine",OBJPROP_COLOR,Red);
   ObjectSet("SLine",OBJPROP_WIDTH,2);
   
   //Swing High
//   ObjectCreate("SHLine",OBJ_HLINE,0,Time[0],SwingHighLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("SHLine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("SHLine",OBJPROP_COLOR,Gold);
//   ObjectSet("SHLine",OBJPROP_WIDTH,1);
   
   //Swing Low
//   ObjectCreate("SLLine",OBJ_HLINE,0,Time[0],SwingLowLine); //name,type,window,time of the first anchor point,price of the first anchor point
//   ObjectSet("SLLine",OBJPROP_STYLE,STYLE_SOLID);
//   ObjectSet("SLLine",OBJPROP_COLOR,PaleGreen);
//   ObjectSet("SLLine",OBJPROP_WIDTH,1);
   
   
   
//   SwingHighLineV=ObjectGet("SHLine",OBJPROP_PRICE1);
//   SwingLowLineV=ObjectGet("SLLine",OBJPROP_PRICE1);
//   EntryLineV=ObjectGet("ELine",OBJPROP_PRICE1);
//   ProfitLineV=ObjectGet("PLine",OBJPROP_PRICE1);
//   LossLineV=ObjectGet("SLine",OBJPROP_PRICE1);
   
   

   
   
//Info box lines. Aeshtetic lines only in display box
  // ObjectCreate("PrettyLine1",OBJ_HLINE,0,Time[0],0); //name,type,window,time of the first anchor point,price of the first anchor point
  // ObjectSet("PrettyLine1",OBJPROP_STYLE,STYLE_SOLID);
  // ObjectSet("PrettyLine1",OBJPROP_XDISTANCE,50);
  // ObjectSet("PrettyLine1",OBJPROP_YDISTANCE,50);
  // ObjectSet("PrettyLine1",OBJPROP_COLOR,Gold);
  // ObjectSet("PrettyLine1",OBJPROP_WIDTH,2);
  }






//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
// fix for debug bug
class CFix { } ExtFix;
// 
int start()
  {
   ShowStats();
  }
//+------------------------------------------------------------------+
//| Bug fix for latest version of MT$                         |
//+------------------------------------------------------------------+
string StringSubstrOld(string x,int a,int b=-1)
  {
   if(a<0) a=0; // Stop odd behaviour
   if(b<=0) b=-1; // new MQL4 EOL flag
   return StringSubstr(x,a,b);
  }
//+------------------------------------------------------------------+
